#ifndef INSERTPETDIALOG_H
#define INSERTPETDIALOG_H

#include <QDialog>
#include <QItemDelegate>
#include "ui_insertpetdialog.h"

class QSqlRelationalTableModel;


class InsertPetDialog : public QDialog, public Ui::InsertPetDialog
{
	Q_OBJECT

public:
	InsertPetDialog(QSqlRelationalTableModel * model, QWidget * parent = 0);

public slots:
	void accept();

private:
	QSqlRelationalTableModel * m_model;

private slots:
	void newRowButton_clicked();
};


class PictureDelegate : public QItemDelegate
{
	Q_OBJECT

	public:
		PictureDelegate(QObject *parent = 0);
		QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
							  const QModelIndex &index) const;

		void setEditorData(QWidget *editor, const QModelIndex &index) const;
		void setModelData(QWidget *editor, QAbstractItemModel *model,
						  const QModelIndex &index) const;

		void updateEditorGeometry(QWidget *editor,
								  const QStyleOptionViewItem &option, const QModelIndex &index) const;
};


class PictureButton : public QPushButton
{
	Q_OBJECT

	public:
		PictureButton(QWidget * parent);
		QVariant rawPicture();

	private:
		QVariant m_data;

	private slots:
		void loadImage();

};

#endif // INSERTPETDIALOG_H
