#include "ownerdialog.h"

#include <QDataWidgetMapper>
#include <QSqlQueryModel>
#include <QSqlRecord>
#include <QLineEdit>
#include <QLabel>


OwnerDialog::OwnerDialog(QWidget * parent)
	: QDialog(parent)
{
	setupUi(this);

	m_model = new QSqlQueryModel(this);
	m_model->setQuery("select * from v_owner_pets");

	m_mapper = new QDataWidgetMapper(this);
	m_mapper->setModel(m_model);

	createDynamicGui();

	m_mapper->toFirst();

	connect(firstButton, SIGNAL(clicked()),
			m_mapper, SLOT(toFirst()));
	connect(previousButton, SIGNAL(clicked()),
			m_mapper, SLOT(toPrevious()));
	connect(nextButton, SIGNAL(clicked()),
			m_mapper, SLOT(toNext()));
	connect(lastButton, SIGNAL(clicked()),
			m_mapper, SLOT(toLast()));
}

void OwnerDialog::createDynamicGui()
{
	QSqlRecord rec(m_model->record());
	QWidget * layoutWidget = new QWidget(scrollWidget);
	QGridLayout *layout = new QGridLayout(layoutWidget);
	QString tmp("%1:");

	for (int i = 0; i < rec.count(); ++i)
	{
		layout->addWidget(new QLabel(tmp.arg(rec.fieldName(i)), layoutWidget), i, 0);
		QLineEdit * w = new QLineEdit(layoutWidget);
		w->setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Preferred);
		layout->addWidget(w, i, 1);
		m_mapper->addMapping(w, i);
	}

	scrollWidget->setWidget(layoutWidget);
}
